package bug;

import javax.xml.soap.*;
import javax.xml.ws.soap.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;

public class Client {

    public static void main(String[] args) throws Exception {

	SaajDetailBug hw = (new SaajDetailBugService()).getSaajDetailBugPort();
        try {
          hw.saajBug();
        } catch (SOAPFaultException sfe) {
	    printSOAPFault(sfe.getFault());
	    return;
        }
        System.out.println("SOAPFault was not thrown.");

    }

  private static void printSOAPFault(SOAPFault sf) throws Exception {
    
    Transformer xfmr = TransformerFactory.newInstance().newTransformer();
    xfmr.setOutputProperty(OutputKeys.INDENT, "yes");
    xfmr.transform(new DOMSource(sf), new StreamResult(System.out));
    System.out.println();
    
  }

}
