package bug;

import javax.jws.*;
import javax.xml.ws.*;
import javax.xml.soap.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;
import javax.xml.ws.soap.SOAPFaultException;
import javax.xml.namespace.QName;

@WebService
public class SaajDetailBug {
  
  public void saajBug() {

    SOAPFaultException sfe;
    try {
      SOAPFactory fac = SOAPFactory.newInstance();
      SOAPFault sf = fac.createFault(
          "This is a fault.",
          new QName("http://schemas.xmlsoap.org/soap/envelope/", "Client"));
      Detail d = sf.addDetail();
      SOAPElement de = d.addChildElement(new QName(
          "http://www.example.com/faults", "myFirstDetail"));
      de.addAttribute(new QName("", "msg"), "This is the first detail message.");
      de = d.addChildElement(new QName(
          "http://www.example.com/faults", "mySecondDetail"));
      de.addAttribute(new QName("", "msg"), "This is the second detail message.");
      sfe = new SOAPFaultException(sf);
      printSOAPFault(sfe.getFault());
    } catch (Exception e) {
      throw new WebServiceException(e);
    }
    throw sfe;

  }

  private static void printSOAPFault(SOAPFault sf) throws Exception {
    
    Transformer xfmr = TransformerFactory.newInstance().newTransformer();
    xfmr.setOutputProperty(OutputKeys.INDENT, "yes");
    xfmr.transform(new DOMSource(sf), new StreamResult(System.out));
    System.out.println();
    
  }

}
